'use strict';

const ContextRemote = require('../../../lib/context.js');
const ContextLocal = require('../../../lib/context-local.js');
const Dataset = require('../../../lib/dataset.js');

// In test mode, cache already opened context in global var 
// so only one context is active for the whole test session
// no matter the number of test files

function Context(args) {
  if (global._sc) {
    global._scn++;
  } else {
    global._scn = 0;
    args = args || {};
    if (args.host || process.env.SKALE_HOST)
      global._sc = ContextRemote(args);
    else
      global._sc = ContextLocal(args);
  } 
  return global._sc;
}

module.exports = {
  Context: Context,
  context: Context,
  HashPartitioner: Dataset.HashPartitioner,
  RangePartitioner: Dataset.RangePartitioner,
  Source: Dataset.Source
};
